local isOffline = false
local event = nil

local offlineAlertButton = nil

-- sound from game_bot
getSoundChannel = function()
  if not g_sounds then
    return
  end
  return g_sounds.getChannel(SoundChannels.Bot)
end

playSound = function(file)
  local soundChannel = getSoundChannel()
  if not soundChannel then
    return
  end
  soundChannel:setEnabled(true)
  soundChannel:stop(0)
  soundChannel:play(file, 0, 1.0)
  return soundChannel
end

stopSound = function()
  local soundChannel = getSoundChannel()
  if not soundChannel then
    return
  end
  soundChannel:stop()
end

function init()
  connect(g_game, {
    onGameStart = online,
    onGameEnd = offline,
  })

  offlineAlertButton = modules.client_topmenu.addLeftButton('offlineAlertButton', tr('Offline Alert'), '/images/topbuttons/audio', toggle, false, 1)
  offlineAlertButton:setOn(false)
  if g_game.isOnline() then
    online()
  end
end

function toggle()
  offlineAlertButton:setOn(not offlineAlertButton:isOn())
  if event then 
    removeEvent(event)
  end
  event = nil
  isOffline = false
end

function terminate()
    disconnect(g_game, {
      onGameStart = online,
      onGameEnd = offline,
    })

    if event then 
      removeEvent(event)
    end
    event = nil

    if offlineAlertButton then
      offlineAlertButton:destroy()
    end
    offlineAlertButton = nil
end

function online()
  if not offlineAlertButton:isOn() then return false end
  isOffline = false
  if event then 
    removeEvent(event)
  end
  event = nil
end

function offline()
  if not offlineAlertButton:isOn() then return false end
  isOffline = true
  event = periodicalEvent(function()
    playSound("/sounds/alarm.ogg")
  end,
  function()
    return isOffline
  end
  , 5000, 1000)
end